# -*- coding: utf-8 -*-
"""
Created on Thu Aug 11 11:08:30 2022

@author: brack28
"""

import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import pdb
from matplotlib.patches import Patch
from matplotlib.text import OffsetFrom
from matplotlib.figure import figaspect

## HZDR Colormap
HHBlue = '#005aa0ff'
HHB80 = '#2473adff'
HHB60 = '#6691c4ff'
HHB40 = '#9bb3d7ff'
HHB20 = '#cdd8ecff'
HHOrange = '#f0781eff'
HHO80 = '#f39150ff'
HHO60 = '#f7af7cff'
HHO40 = '#fbcba8ff'
HHO20 = '#fde6d4ff'
HHGreen = '#8cb423ff'
HHG80 = '#a1c445ff'
HHG60 = '#b8d46cff'
HHG40 = '#cce89eff'
HHG20 = '#e6f5ceff'
HHGrayDark = '#515151ff'
HHGrayMiddle = '#9c9c9cff'
HHGrayLight = '#b9b9b9ff'


## Daten einlesen
df_Draco = pd.read_csv('Bunches_Draco.csv')
df_UPTD = pd.read_csv('Bunches_UPTD_2.csv')
df_ELBE = pd.read_csv('Bunches_ELBE.csv')
df_Linac = pd.DataFrame(columns=('Time','Linac','Width'))
LinacList = []

for i in range (0, 350):
    df_Linac.at[i,'Time']=i*330e-12
    if i > 0:
        df_Linac.at[i,'Time']= i*330e-12 + 30e-12
    else:
        df_Linac.at[i,'Time']= 0
    df_Linac.at[i,'Linac']= 3e-8
    df_Linac.at[i,'Width']= 30e-12
    
## Initialisiere eine Figure mit subplots die dann übereinander liegen
# fig, (ax1,ms_e,sec_e,ns_p,ms_p,sec_p) = plt.subplots(ncols= 3, nrows = 2, gridspec_kw={'width_ratios': [2,2,1], 'height_ratios': [1,1]}, sharey=True)
plt.rcParams.update({'hatch.color': 'white'})  # weiße Linien als Fuellung

plt.rcParams["figure.dpi"] = 1200 ## Höhere Auflösung beim Darstellen in spyder

w, h = figaspect(0.33)
fig_e = plt.figure(figsize=(0.5*w,0.5*h), constrained_layout=False)
# gs_e = fig_e.add_gridspec(nrows=1, ncols=4, height_ratios=[1,1], width_ratios=[1,0.5,1,0.5])
gs_e = fig_e.add_gridspec(nrows=1, ncols=4, width_ratios=[1,0.5,1,0.5])

ns_e = fig_e.add_subplot(gs_e[0, 0])
us_e = fig_e.add_subplot(gs_e[0, 1])
ms_e = fig_e.add_subplot(gs_e[0, 2])
sec_e = fig_e.add_subplot(gs_e[0, 3])

fig_p = plt.figure(figsize=(0.5*w,0.5*h),constrained_layout=False)
gs_p = fig_p.add_gridspec(nrows=1, ncols=4, width_ratios=[1,0.5,1,0.5])

ns_p = fig_p.add_subplot(gs_p[0, 0])
us_p = fig_p.add_subplot(gs_p[0, 1])
ms_p = fig_p.add_subplot(gs_p[0, 2])
sec_p = fig_p.add_subplot(gs_p[0, 3])

# ratio = 0.5
# xleft_e, xright_e = fig_e.get_xlim()
# ybottom_e, ytop_e = fig_e.get_ylim()
# fig_e.set_aspect(abs((xright_e-xleft_e)/(ybottom_e-ytop_e))*ratio)

# Setze die Bereiche zwischen Unterbrechungen
ns_e.set_xlim([-1e-8,12e-8])
ns_e.set_ylim([1e-9,1e-1])

us_e.set_xlim([25e-6,350e-6])
us_e.set_ylim([1e-9,1e-1])

ms_e.set_xlim([40e-3,200e-3])
ms_e.set_ylim([1e-9,1e-1])

sec_e.set_xlim([160,350])
sec_e.set_ylim([1e-9,1e-1])

ns_p.set_xlim([-1e-8,12e-8])
ns_p.set_ylim([1e-10,9e2])

us_p.set_xlim([25e-6,350e-6])
us_p.set_ylim([1e-10,9e2])

ms_p.set_xlim([40e-3,200e-3])
ms_p.set_ylim([1e-10,9e2])

sec_p.set_xlim([160,350])
sec_p.set_ylim([1e-10,9e2])

# Beschriftung der x-Achsen
ns_e.set_xticks([0,77e-9], ha = 'right')
ns_e.tick_params(axis='x',bottom=True,top=False,direction='in', labelbottom=True, labeltop=False)
ns_e.xaxis.set_label_position('bottom')
ns_e.set_xticklabels(['0','77'])
ns_e.set_xlabel('[ns]')

us_e.set_xticks([63e-6,300e-6])
us_e.set_xticklabels(['63','300'])
us_e.tick_params(axis='x',bottom=True,top=False,direction='in', labelbottom=True, labeltop=False)
us_e.xaxis.set_label_position('bottom')
labelcolor = us_e.get_xticklabels()
labelcolor[1].set_color(HHBlue)
labelcolor[1].set_ha("center")
us_e.set_xlabel('[$\mathrm{\mu}$s]')

ms_e.set_xticks([0.04,0.1,0.160])
ms_e.set_xticklabels(['40','100','160'])
ms_e.tick_params(axis='x',bottom=True,top=False,direction='in', labelbottom=True, labeltop=False)
ms_e.xaxis.set_label_position('bottom')
labelcolor = ms_e.get_xticklabels()
labelcolor[1].set_color(HHB60)
labelcolor[2].set_color('crimson')
ms_e.set_xlabel('[ms]')

sec_e.set_xticks([160,240])
sec_e.tick_params(axis='x',bottom=True,top=False,direction='in', labelbottom=True, labeltop=False)
sec_e.xaxis.set_label_position('bottom')
labelcolor = sec_e.get_xticklabels()
labelcolor[1].set_color('palevioletred')
labelcolor[1].set_ha("left")
sec_e.set_xlabel('[s]')

ns_p.set_xticks([0,20e-9,100e-9], ha = 'right')
ns_p.tick_params(axis='x',bottom=True,top=False,direction='in', labelbottom=True, labeltop=False)
label = ns_p.get_xticklabels()
# label[1].set_ha("right")
ns_p.xaxis.set_label_position('bottom')
ns_p.set_xticklabels(['0','20','100'])
labelcolor = ns_p.get_xticklabels()
labelcolor[1].set_color(HHGreen)
ns_p.set_xlabel('[ns]')

us_p.set_xticks([25e-6,350e-6])
us_p.set_xticklabels(['25','350'])
label = us_p.get_xticklabels()
label[1].set_ha("right")
us_p.tick_params(axis='x',bottom=True,top=False,direction='in', labelbottom=True, labeltop=False)
us_p.xaxis.set_label_position('bottom')
us_p.set_xlabel('[$\mathrm{\mu}$s]')

ms_p.set_xticks([0.04,0.115,0.16])
ms_p.set_xticklabels(['40','115','160'])
# label = ms_p.get_xticklabels()
# label[0].set_ha("left")
ms_p.tick_params(axis='x',bottom=True,top=False,direction='in', labelbottom=True, labeltop=False)
ms_p.xaxis.set_label_position('bottom')
labelcolor = ms_p.get_xticklabels()
labelcolor[1].set_color(HHOrange)
ms_p.set_xlabel('[ms]')

sec_p.set_xticks([200,300])
sec_p.tick_params(axis='x',bottom=True,top=False,direction='in', labelbottom=True, labeltop=False)
label = sec_p.get_xticklabels()
sec_p.xaxis.set_label_position('bottom')
labelcolor = sec_p.get_xticklabels()
labelcolor[0].set_color(HHO60)
labelcolor[1].set_color(HHG60)
sec_p.set_xlabel('[s]')

# hide the spines between axes
ns_e.spines['right'].set_visible(False)
us_e.spines['left'].set_visible(False)
us_e.spines['right'].set_visible(False)
ms_e.spines['left'].set_visible(False)
ms_e.spines['right'].set_visible(False)
sec_e.spines['left'].set_visible(False)
# Protons
ns_p.spines['right'].set_visible(False)
us_p.spines['left'].set_visible(False)
us_p.spines['right'].set_visible(False)
ms_p.spines['left'].set_visible(False)
ms_p.spines['right'].set_visible(False)
sec_p.spines['left'].set_visible(False)

# This looks pretty good, and was fairly painless, but you can get that
# cut-out diagonal lines look with just a bit more work. The important
# thing to know here is that in axes coordinates, which are always
# between 0-1, spine endpoints are at these locations (0,0), (0,1),
# (1,0), and (1,1).  Thus, we just need to put the diagonals in the
# appropriate corners of each of our axes, and so long as we use the
# right transform and disable clipping.

d = .015 # how big to make the diagonal lines in axes coordinates
# arguments to pass plot, just so we don't keep repeating them
kwargs = dict(transform=ns_e.transAxes, color='k', clip_on=False)
ns_e.plot((1-d,1+d), (-d,+d), **kwargs)
ns_e.plot((1-d,1+d),(1-d,1+d), **kwargs)

kwargs.update(transform=us_e.transAxes)  # switch to the bottom axes
us_e.plot((-2*d,+2*d), (1-d,1+d), **kwargs)
us_e.plot((-2*d,+2*d), (-d,+d), **kwargs)
us_e.plot((1-2*d,1+2*d), (-d,+d), **kwargs)
us_e.plot((1-2*d,1+2*d),(1-d,1+d), **kwargs)

kwargs.update(transform=ms_e.transAxes)  # switch to the bottom axes
ms_e.plot((-d,+d), (1-d,1+d), **kwargs)
ms_e.plot((-d,+d), (-d,+d), **kwargs)
ms_e.plot((1-d,1+d), (-d,+d), **kwargs)
ms_e.plot((1-d,1+d),(1-d,1+d), **kwargs)

kwargs.update(transform=sec_e.transAxes)  # switch to the bottom axes
sec_e.plot((-2*d,+2*d), (1-d,1+d), **kwargs)
sec_e.plot((-2*d,+2*d), (-d,+d), **kwargs)

kwargs = dict(transform=ns_p.transAxes, color='k', clip_on=False)
ns_p.plot((1-d,1+d), (-d,+d), **kwargs)
ns_p.plot((1-d,1+d),(1-d,1+d), **kwargs)

kwargs.update(transform=us_p.transAxes)  # switch to the bottom axes
us_p.plot((-2*d,+2*d), (1-d,1+d), **kwargs)
us_p.plot((-2*d,+2*d), (-d,+d), **kwargs)
us_p.plot((1-2*d,1+2*d), (-d,+d), **kwargs)
us_p.plot((1-2*d,1+2*d),(1-d,1+d), **kwargs)

kwargs.update(transform=ms_p.transAxes)  # switch to the bottom axes
ms_p.plot((-d,+d), (1-d,1+d), **kwargs)
ms_p.plot((-d,+d), (-d,+d), **kwargs)
ms_p.plot((1-d,1+d), (-d,+d), **kwargs)
ms_p.plot((1-d,1+d),(1-d,1+d), **kwargs)

kwargs.update(transform=sec_p.transAxes)  # switch to the bottom axes
sec_p.plot((-2*d,+2*d), (1-d,1+d), **kwargs)
sec_p.plot((-2*d,+2*d), (-d,+d), **kwargs)

# What's cool about this is that now if we vary the distance between
# ax and ms_e via f.subplots_adjust(hspace=...) or plt.subplot_tool(),
# the diagonal lines will move accordingly, and stay right at the tips
# of the spines they are 'breaking'

## Abstand zwischen Bereichen
# fig.subplots_adjust(wspace=0.25)
# fig.subplots_adjust(hspace=0.16)

# Einstellung y-Achse
ns_e.tick_params(axis='y',which='major', left=True,right=False,direction='in')
ns_e.tick_params(axis='y',which='minor', left=False,right=False,direction='in')
ylabel1 = ns_e.get_yticklabels()
ylabel1[1].set_va("bottom")
us_e.axes.yaxis.set_visible(False)
ms_e.axes.yaxis.set_visible(False)
sec_e.tick_params(axis='y',which='major', left=False,right=True,direction='in', labelleft = False)
sec_e.tick_params(axis='y',which='minor', left=False,right=False,direction='in')

ns_p.tick_params(axis='y',which='major', left=True,right=False,direction='in')
ns_p.tick_params(axis='y',which='minor', left=False,right=False,direction='in')
ylabel4 = ns_p.get_yticklabels()
ylabel4[5].set_va("top")
us_p.axes.yaxis.set_visible(False)
ms_p.axes.yaxis.set_visible(False)
sec_p.tick_params(axis='y',which='major', left=False,right=True,direction='in', labelleft = False)
sec_p.tick_params(axis='y',which='minor', left=False,right=False,direction='in')

ns_e.set_yscale('log')
us_e.set_yscale('log')
ms_e.set_yscale('log')
sec_e.set_yscale('log')

ns_p.set_yscale('log')
ms_p.set_yscale('log')
sec_p.set_yscale('log')
us_p.set_yscale('log')

## Erster Bereich

widthns_e = 2e-9
ns_e.bar(df_ELBE['Time'],df_ELBE['ELBE max'],widthns_e, align='edge', alpha=1, color = HHBlue)
ns_e.bar(df_ELBE['Time']+4E-9,df_ELBE['ELBE sync'],widthns_e, align='edge', alpha=1, color = 'crimson')
ns_e.bar(df_ELBE['Time']+8E-9,df_ELBE['ELBE iso'],widthns_e, align='edge', alpha=1, color = HHB60)
# ns_e.bar(df_Linac['Time'],df_Linac['Linac'],df_Linac['Width'], align='edge', alpha=1, color = 'black')
ns_e.bar(df_ELBE['Time']+12E-9,df_ELBE['ELBE Ref'],widthns_e, align='edge', alpha=1, color = 'palevioletred')

## Mikrosekunden

widthus_e = 2.5e-3
us_e.bar(df_ELBE['Time'],df_ELBE['ELBE max'],df_ELBE['Width'], align='edge', alpha=1, color = HHBlue, hatch = '||||||')
us_e.bar(df_ELBE['Time'],df_ELBE['ELBE sync'],df_ELBE['Width'], align='edge', alpha=1, color = 'crimson', hatch = '||||||')
us_e.bar(df_ELBE['Time'],df_ELBE['ELBE iso'],df_ELBE['Width'], align='edge', alpha=1, color = HHB60, hatch = '||||||')
us_e.bar(df_ELBE['Time'],df_ELBE['ELBE Ref'],df_ELBE['Width'], align='edge', alpha=1, color = 'palevioletred', hatch = '||||||')
# us_e.bar(df_ELBE['Time'],df_ELBE['ELBE sync'],df_ELBE['Width'], align='edge', alpha=1, color = HHB80, hatch = '||||||')

## Zweiter Bereich

widthms_e = 2.5e-3
ms_e.bar(df_ELBE['Time'],df_ELBE['ELBE max'],widthms_e, align='edge', alpha=1, color = HHBlue)
ms_e.bar(df_ELBE['Time'],df_ELBE['ELBE sync'],widthms_e, align='edge', alpha=1, color = 'crimson')
ms_e.bar(df_ELBE['Time'],df_ELBE['ELBE iso'],df_ELBE['Width'], align='edge', alpha=1, color = HHB60, hatch = '||||||')
ms_e.bar(df_ELBE['Time'],df_ELBE['ELBE Ref'],df_ELBE['Width'], align='edge', alpha=1, color = 'palevioletred', hatch = '||||||')

## Dritter Bereich 

sec_e.bar(df_ELBE['Time'],df_ELBE['ELBE max'],df_ELBE['Width'], align='edge', alpha=1, color = HHBlue)
sec_e.bar(df_ELBE['Time'],df_ELBE['ELBE sync'],df_ELBE['Width'], align='edge', alpha=1, color = HHB80)
sec_e.bar(df_ELBE['Time'],df_ELBE['ELBE iso'],df_ELBE['Width'], align='edge', alpha=1, color = HHB60)
sec_e.bar(df_ELBE['Time'],df_ELBE['ELBE Ref'],df_ELBE['Width'], align='edge', alpha=1, color = 'palevioletred', hatch = '||||||')

## Vierter Bereich
ns_p.bar(df_Draco['Time'],df_Draco['Draco UHDR'],df_Draco['Width'], align='edge', alpha=1, color=HHGreen)
ns_p.bar(df_Draco['Time'],df_Draco['Draco Mouse'],df_Draco['Width'], align='edge', alpha=1, color=HHG40)

ns_p.bar(df_UPTD['Time'],df_UPTD['UPTD max'],df_UPTD['Width']*2, align='edge', alpha=1, color=HHOrange)
ns_p.bar(df_UPTD['Time'],df_UPTD['UPTD Ref'],df_UPTD['Width']*2, align='edge', alpha=1, color=HHO60)

## Mikrosekunden

us_p.bar(df_UPTD['Time'],df_UPTD['UPTD max'],df_UPTD['Width'], align='edge', alpha=1, color=HHOrange, hatch = '||||')
us_p.bar(df_UPTD['Time'],df_UPTD['UPTD Ref'],df_UPTD['Width'], align='edge', alpha=1, color=HHO60, hatch = '||||')

## Fuenfter Bereich
ms_p.bar(df_Draco['Time'],df_Draco['Draco UHDR'],df_Draco['Width'], align='edge', alpha=1, color=HHG40)

ms_p.bar(df_UPTD['Time'],df_UPTD['UPTD max'],df_UPTD['Width'], align='edge', alpha=1, color=HHOrange, hatch = '||||')
ms_p.bar(df_UPTD['Time'],df_UPTD['UPTD Ref'],df_UPTD['Width'], align='edge', alpha=1, color=HHO60, hatch = '||||')

## Sechster Bereich 

sec_p.bar(df_Draco['Time'],df_Draco['Draco Mouse'],6, align='edge', alpha=1, color=HHG40)#,  hatch = '||||')

sec_p.bar(df_UPTD['Time'],df_UPTD['UPTD max'],df_UPTD['Width'], align='edge', alpha=1, color=HHOrange)
sec_p.bar(df_UPTD['Time'],df_UPTD['UPTD Ref'],df_UPTD['Width'], align='edge', alpha=1, color=HHO60, hatch = '||||')

# ##### Pfeile und Beschriftungen 

# arrow_args = dict(arrowstyle="<->", shrinkA= 0, shrinkB= 0)

# # Micropulsabstand
ns_e.annotate('',
              xy=(5e-9, 1e-4),
              xytext=(82e-9, 1e-4), 
              arrowprops=dict(arrowstyle="|-|", shrinkA= 0, shrinkB= 0, mutation_scale=3),
              va='center'
              )

ns_e.annotate('77 ns',
              xy=(42e-9, 1e-5), xycoords=ns_e.transData,
              va= 'center',
              ha= 'center',
              bbox=dict(boxstyle="round", fc="w")
              )

# # Beschriftung ELBE max
# ms_e.annotate('',
#               xy=(3e-9, 4e-4), xycoords=ns_e.transData,
#               xytext=(3e-3, 4e-4), textcoords=ms_e.transData,
#               arrowprops=arrow_args)

# ms_e.annotate('0.3 ms',
#               xy=(224e-9, 7e-4), xycoords=ns_e.transData,
#               va= 'center',
#               ha= 'right'
#               )

# # Beschriftung ELBE synchro
# ms_e.annotate('',
#               xy=(7e-9, 4e-5), xycoords=ns_e.transData,
#               xytext=(169e-3, 4e-5), textcoords=ms_e.transData,
#               arrowprops=arrow_args)

# ms_e.annotate('164 ms',
#               xy=(224e-9, 7e-5), xycoords=ns_e.transData,
#               va= 'center',
#               ha= 'right'
#               )

ms_e.annotate('',
              xy=(121e-3, 1e-4), xycoords=ms_e.transData,
              xytext=(161e-3, 1e-4), textcoords=ms_e.transData,
              arrowprops=dict(arrowstyle="|-|", shrinkA= 0, shrinkB= 0,mutation_scale=3))

ms_e.annotate('40 ms',
              xy=(140e-3, 1e-5), xycoords=ms_e.transData,
              va= 'center',
              ha= 'center',
              bbox=dict(boxstyle="round", fc="w")
              )

# ms_e.annotate('40 ms',
#               xy=(90e-3, 5e-4), xycoords=ms_e.transData,
#               va= 'center',
#               ha= 'center',
#               bbox=dict(boxstyle="round", fc="w")
#               )

# # Beschriftung ELBE iso
# ms_e.annotate('',
#               xy=(11e-9, 4e-7), xycoords=ns_e.transData,
#               xytext=(100e-3, 4e-7), textcoords=ms_e.transData,
#               arrowprops=arrow_args)

# ms_e.annotate('100 ms',
#               xy=(224e-9, 7e-7), xycoords=ns_e.transData,
#               va= 'center',
#               ha= 'right'
#               )

# # Beschriftung ELBE REF
# sec_e.annotate('',
#               xy=(17e-9, 4e-9), xycoords=ns_e.transData,
#               xytext=(240, 4e-9), textcoords=sec_e.transData,
#               arrowprops=arrow_args)

# sec_e.annotate('240 s',
#               xy=(224e-9, 7e-9), xycoords=ns_e.transData,
#               va= 'center',
#               ha= 'right'
#               )

# ## Beschriftungen und Pfeile Protonen

# # Beschriftung Draco UHDR
# ns_p.annotate('',
#               xy=(0e-9, 4e-2),
#               xytext=(20e-9, 4e-2), 
#               arrowprops=arrow_args,
#               va='center'
#               )

# ns_p.annotate('20 ns',
#               xy=(45e-9, 9e-2), xycoords=ns_p.transData,
#               va= 'center',
#               ha= 'right'
#               )

# # Beschriftung UPTD max
ns_p.annotate('',
              xy=(76.5e-9, 5e-7), xycoords=ns_p.transData,
              xytext=(67e-9, 5e-7), textcoords=ns_p.transData,
              arrowprops=dict(arrowstyle="|-|", shrinkA= 0, shrinkB= 0, mutation_scale=3))

ns_p.annotate('9.4 ns',
              xy=(95e-9, 5e-5), xycoords=ns_p.transData,
              va= 'center',
              ha= 'right',
              bbox=dict(boxstyle="round", fc="w")
              )

# ms_p.annotate('',
#               xy=(0e-9, 1e-6), xycoords=ns_p.transData,
#               xytext=(115e-3, 1e-6), textcoords=ms_p.transData,
#               arrowprops=arrow_args)

# ms_p.annotate('115 ms',
#               xy=(100e-3, 6e-6), xycoords=ms_p.transData,
#               va= 'center',
#               ha= 'right'
#               )

# # Beschriftung UPTD Ref
# sec_p.annotate('',
#               xy=(0e-9, 6e-10), xycoords=ns_p.transData,
#               xytext=(200, 6e-10), textcoords=sec_p.transData,
#               arrowprops=arrow_args)

# sec_p.annotate('200 s',
#               xy=(200e-3, 2e-9), xycoords=ms_p.transData,
#               va= 'center',
#               ha= 'right'
#               )

sec_p.annotate('',
              xy=(162, 5e-7), xycoords=sec_p.transData,
              xytext=(182, 5e-7), textcoords=sec_p.transData,
              arrowprops=dict(arrowstyle="|-|", shrinkA= 0, shrinkB= 0,mutation_scale=3))

# sec_p.annotate('20 s',
#               xy=(140, 1e-2), xycoords=sec_p.transData,
#               va= 'center',
#               ha= 'right',
#               bbox=dict(boxstyle="round", fc="w")
#               )

sec_p.annotate('20 s',
              xy=(170, 3e-5), xycoords=sec_p.transData,
              va= 'center',
              ha= 'center',
              bbox=dict(boxstyle="round", fc="w")
              )

# sec_p.annotate('',
#               xy=(0, 1e-2), xycoords=ns_p.transData,
#               xytext=(600, 1e-2), textcoords=sec_p.transData,
#               arrowprops=arrow_args)

# sec_p.annotate('20 s',
#               xy=(500, 3e-2), #xycoords=ns_p.transData,
#               va= 'center',
#               ha= 'right'
#               )


## Legende leider manuell erstellt :(
legend_elements = [Patch(facecolor=HHBlue,alpha=1,label='ELBE$\mathrm{_{UHDR}^{max}}$'),
                   Patch(facecolor='crimson',alpha=1,label='ELBE$\mathrm{_{UHDR}^{syn}}$'),
                   Patch(facecolor=HHB60,alpha=1,label='ELBE$\mathrm{_{UHDR}^{iso}}$'),
                   Patch(facecolor='palevioletred',alpha=1,label='ELBE$\mathrm{_{ref}}$')
                   ]
# Shrink current axis by 20%
box = sec_e.get_position()
sec_e.set_position([box.x0, box.y0, box.width * 0.8, box.height])

sec_e.legend(handles=legend_elements, fontsize=8, loc='center left', bbox_to_anchor=(1, 0.5))

# # Put a legend to the right of the current axis
# sec_e.legend(loc='center left', bbox_to_anchor=(1, 0.5))

legend_elements = [Patch(facecolor=HHGreen,alpha=1,label='DRACO$\mathrm{_{single}}$'),
                   Patch(facecolor=HHG40,alpha=1,label='DRACO$\mathrm{_{accu}}$'),
                   Patch(facecolor=HHOrange,alpha=1,label='UPTD$\mathrm{_{UHDR}}$'),
                   Patch(facecolor=HHO60,alpha=1,label='UPTD$\mathrm{_{ref}}$')
                   ]
# ms_p.legend(handles=legend_elements, fontsize=8, loc='upper center')

# Shrink current axis by 20%
box = sec_p.get_position()
sec_p.set_position([box.x0, box.y0, box.width * 0.8, box.height])
sec_p.legend(handles=legend_elements, fontsize=8, loc='center left', bbox_to_anchor=(1, 0.5))

#fig.text(0.5, -0.01, 'Dose application time', ha='center')
fig_e.text(0.03, 0.5, 'Dose per bunch [Gy]', va='center', rotation='vertical')
fig_e.text(0.5, -0.15, 'Dose application time', ha='center')
fig_p.text(0.03, 0.5, 'Dose per bunch [Gy]', va='center', rotation='vertical')
fig_p.text(0.5, -0.15, 'Dose application time', ha='center')
# plt.title('Dose application time', x=1, y=-0.45)

fig_e.savefig('BunchStructure_e.pdf', bbox_inches='tight')
fig_e.savefig('BunchStructure_e.svg', bbox_inches='tight')
fig_e.savefig('BunchStructure_e.png', dpi=600, bbox_inches='tight')
fig_p.savefig('BunchStructure_p.pdf', bbox_inches='tight')
fig_p.savefig('BunchStructure_p.svg', dpi=1600, bbox_inches='tight')
fig_p.savefig('BunchStructure_p.png', dpi=600, bbox_inches='tight')
plt.show()


